#include <iostream>
#include "mpi.h"
#define N 3

int main(int argc, char **argv) {
  int i;
  int rank;
  int a[N], b[N];

  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);
  for(i=0;i<N;i++) {
    a[i] = i+rank*N;
  }

	std::cout << "\n" << rank << ": a[]=";
  for(i=0;i<N;i++) {
		std::cout << a[i] << ", ";
  }

  MPI_Scan(a, b, N, MPI_INT, MPI_SUM, MPI_COMM_WORLD);

	std::cout << "\n" << rank << ": b[]=";
  for(i=0;i<N;i++) {
		std::cout << b[i] << ", ";
  }

  MPI_Finalize();

  return 0;
}
